
local MakePlayerCharacter = require "prefabs/player_common"


local assets = {

	Asset("SCRIPT", "scripts/prefabs/player_common.lua"),

        Asset( "ANIM", "anim/player_basic.zip" ),
        Asset( "ANIM", "anim/player_idles_shiver.zip" ),
        Asset( "ANIM", "anim/player_actions.zip" ),
        Asset( "ANIM", "anim/player_actions_axe.zip" ),
        Asset( "ANIM", "anim/player_actions_pickaxe.zip" ),
        Asset( "ANIM", "anim/player_actions_shovel.zip" ),
        Asset( "ANIM", "anim/player_actions_blowdart.zip" ),
        Asset( "ANIM", "anim/player_actions_eat.zip" ),
        Asset( "ANIM", "anim/player_actions_item.zip" ),
        Asset( "ANIM", "anim/player_actions_uniqueitem.zip" ),
        Asset( "ANIM", "anim/player_actions_bugnet.zip" ),
        Asset( "ANIM", "anim/player_actions_fishing.zip" ),
        Asset( "ANIM", "anim/player_actions_boomerang.zip" ),
        Asset( "ANIM", "anim/player_bush_hat.zip" ),
        Asset( "ANIM", "anim/player_attacks.zip" ),
        Asset( "ANIM", "anim/player_idles.zip" ),
        Asset( "ANIM", "anim/player_rebirth.zip" ),
        Asset( "ANIM", "anim/player_jump.zip" ),
        Asset( "ANIM", "anim/player_amulet_resurrect.zip" ),
        Asset( "ANIM", "anim/player_teleport.zip" ),
        Asset( "ANIM", "anim/wilson_fx.zip" ),
        Asset( "ANIM", "anim/player_one_man_band.zip" ),
        Asset( "ANIM", "anim/shadow_hands.zip" ),
        Asset( "SOUND", "sound/sfx.fsb" ),
        Asset( "SOUND", "sound/willow.fsb" ),
        Asset( "ANIM", "anim/beard.zip" ),

        	Asset( "ANIM", "anim/aqua.zip" ),
		Asset( "ANIM", "anim/ghost_aqua_build.zip" ),
		-- Don't forget to include your character's custom assets!
        
}
local prefabs = {}

-- Custom starting items
local start_inv = {
}

-- When the character is revived from human
local function onbecamehuman(inst)
	-- Set speed when reviving from ghost (optional)
	inst.components.locomotor:SetExternalSpeedMultiplier(inst, "aqua_speed_mod", 1)
end

local function onbecameghost(inst)
	-- Remove speed modifier when becoming a ghost
   inst.components.locomotor:RemoveExternalSpeedMultiplier(inst, "aqua_speed_mod")
end

-- When loading or spawning the character
local function onload(inst)
    inst:ListenForEvent("ms_respawnedfromghost", onbecamehuman)
    inst:ListenForEvent("ms_becameghost", onbecameghost)

    if inst:HasTag("playerghost") then
        onbecameghost(inst)
    else
        onbecamehuman(inst)
    end
end


-- This initializes for both the server and client. Tags can be added here.
local common_postinit = function(inst) 
	-- Minimap icon
	inst.MiniMapEntity:SetIcon( "aqua.tex" )
end

-- This initializes for the server only. Components are added here.
local master_postinit = function(inst)
	-- choose which sounds this character will play
	inst.soundsname = "wilson"
	
	-- Uncomment if "wathgrithr"(Wigfrid) or "webber" voice is used
    --inst.talker_path_override = "dontstarve_DLC001/characters/"
	
	-- Stats	
	inst.components.health:SetMaxHealth(255)
	inst.components.hunger:SetMax(80)
	inst.components.sanity:SetMax(99)

	--Դ 

	inst.components.health.absorb = 0.3

	--

	inst.components.eater.strongstomach = true

	--˺

	inst.components.health.fire_damage_scale = 2

	--￿san

	inst.components.sanity.neg_aura_mult = 2

	--ҹ

	inst.components.sanity.night_drain_mult = 0

	--Զظ

	 inst.components.health:StartRegen(3, 20)

	--sanظ

	inst.components.sanity.dapperness = TUNING.DAPPERNESS_TINY

	--ƶٶ

	inst.components.locomotor.walkspeed =(TUNING.WILSON_WALK_SPEED * 1.2)
	inst.components.locomotor.runspeed = (TUNING.WILSON_RUN_SPEED * 1.2)

	--GOD BLOW

	inst.components.combat:SetDefaultDamage(20)

	--Ѫ

	inst.components.hunger:SetKillRate(TUNING.WILSON_HEALTH/TUNING.STARVE_KILL_TIME*1.2) 
	
	-- Damage multiplier (optional)
    inst.components.combat.damagemultiplier = 1.3
	
	-- Hunger rate (optional)
	inst.components.hunger.hungerrate = 1.2 * TUNING.WILSON_HUNGER_RATE

	--

	if TUNING.AQUA == true then
		inst:AddComponent("ABC")
		inst.components.sanityaura.aurafn = function(inst, observer)
	
				return TUNING.ABC_TINY
			end
			return 0
		end
	end
	
	local function sanityfn(inst)
		if TUNING.AQUA.SERIOUS_SIDE == true then
			local w = TheWorld.state
			if w.israining == false then
				if inst.nanodeath == true then
					return -(TUNING.ABC_TINY)
			end
		end
		return 0
	end
	inst.components.sanity.custom_rate_fn = sanityfn

	


	inst.OnLoad = onload
    inst.OnNewSpawn = onload
	
end



return MakePlayerCharacter("aqua", prefabs, assets, common_postinit, master_postinit, start_inv)
